C--SEAWAT: THIS FILE HAS BEEN MODIFIED TO WORK WITH THE SEAWAT PROGRAM.
C--SEAWAT: BECAUSE ALL VARIABLES IN SEAWAT ARE DOUBLE PRECISION, ALL
C--SEAWAT: LMT SUBROUTINES WERE MODIFIED TO WRITE SINGLE PRECISION, IF
C--SEAWAT: THE OUTPUT FILE IS FOR A SUBSEQUENT MT3DMS SIMULATION, OR 
C--SEAWAT: DOUBLE PRECISION IF THE OUTPUT FILE IS THE TEMPORARY FILE 
C--SEAWAT: USED BY SEAWAT TO PASS FLOW INFORMATION TO MT3DMS SUBROUTINES.
C
C--SEAWAT: 9/27/07--TO ELIMINATE $FILE.UMT, NEEDED TO REPLACE THE FOLLOWING
C--SEAWAT:   ARGUMENTS WITH GX(LCBUFF): Y(LCDH),Y(LCQX),Y(LCQY),Y(LCQZ),
C--SEAWAT:                              Y(LCQSTO),IY(LCIB),IY(LTIRCH),
C--SEAWAT:                              Y(LTRECH),IY(LTIEVT),Y(LTEVTR)
C
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C Beginning of LMT6.INC
C Version 6.0: 05-25-2001
C         6.1: 05-01-2002
C         6.2: 07-15-2003
C         6.3: 05-10-2005
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
C INSERT THE FOLLOWING STATEMENTS INTO MODFLOW-2000 MAIN PROGRAM
C IMMEDIATELY AFTER CALLS TO ALL BUDGET SUBROUTINES.
C ----------------------------------------------------------------------
C
C--AT 1st TIME STEP AND 1st STRESS PERIOD,
C--CHECK AND SET UP Link-MT3DMS OPTIONS
      IF(KKSTP*KKPER.EQ.1) THEN
        ISS_MT3D=1  
        DO KPER_MT3D=1,NPER
          IF(ISSFLG(KPER_MT3D).EQ.0) THEN
            ISS_MT3D=0
            EXIT
          ENDIF
        ENDDO
        CALL LMT6BAS6(INUNIT,IOUT,NCOL,NROW,NLAY,NPER,ISS_MT3D,NODES,
     &   IUNIT,CUNIT,NIUNIT,IG(LCIBOU),IMT3D,ILMTHEAD)
      ENDIF
C
C--IF Link-MT3DMS PACKAGE IF NOT USED, SKIP
      IF(IMT3D.GT.0) THEN
C
C--WRITE A NOTIFICATION LINE TO MODFLOW OUTPUT FILE
        WRITE(IOUT,9876) IMT3D,KKSTP,KKPER
 9876   FORMAT(/1X,'SAVING SATURATED THICKNESS AND FLOW TERMS ON UNIT',
     &   I5,' FOR MT3DMS',/1X,'BY THE LINK-MT3DMS PACKAGE V6.3',
     &   ' AT TIME STEP',I5,', STRESS PERIOD',I5/)
C
C--COLLECT AND SAVE ALL RELEVANT FLOW MODEL INFORMATION
C--SEAWAT: USE VDF SUBROUTINES IF IUNIT(57) GREATER THAN ZERO
        IF(IUNIT(57).GT.0) THEN
            IF(IUNIT(1).GT.0) CALL LMT6BCF6VD(GZ(LCHNEW),IG(LCIBOU),
     &        GX(LCCR),GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),DELT,
     &        RX(LCSC1),RX(LCSC2),GX(LCHOLD),GX(LCBOTM),NBOTM,NCOL,NROW,
     &        NLAY,KKSTP,KKPER,GX(LCBUFF),IMT3D,
     &        GX(LCDELR),GX(LCDELC),INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(23).GT.0) CALL LMT6LPF1VD(GZ(LCHNEW),IG(LCIBOU),
     &        GX(LCCR),GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),DELT,
     &        X(LCSC1),X(LCSC2),GX(LCHOLD),GX(LCBOTM),NBOTM,NCOL,NROW,
     &        NLAY,KKSTP,KKPER,GX(LCBUFF),IMT3D,
     &        GX(LCDELR),GX(LCDELC),INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(37).GT.0) CALL LMT6HUF2VD(GZ(LCHNEW),IG(LCIBOU),
     &        GX(LCCR),GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),
     &        DELT,GX(LCHOLD),X(LCSC1),GX(LCBOTM),NBOTM,
     &        NCOL,NROW,NLAY,KKSTP,KKPER,
     &        X(LCHUFTHK),NHUF,IG(LCIZON),NZONAR,GX(LCRMLT),NMLTAR,
     &        GX(LCDELR),GX(LCDELC),GX(LCBUFF),IMT3D,INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(2).GT.0) CALL LMT6WEL6(NWELLS,MXWELL,NWELVL,
     &        RX(LCWELL),IG(LCIBOU),NCOL,NROW,NLAY,KKSTP,KKPER,IMT3D,
     &        INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(3).GT.0) CALL LMT6DRN6VD(NDRAIN,MXDRN,NDRNVL,
     &        RX(LCDRAI),GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,
     &        KKPER,IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(8).GT.0) CALL LMT6RCH6VD(NRCHOP,IR(LCIRCH),
     &        RX(LCRECH),IG(LCIBOU),NROW,NCOL,NLAY,KKSTP,KKPER,
     &        GX(LCBUFF),IMT3D,INUHF,GX(LCBUFF),GX(LCBUFF))
            IF(IUNIT(5).GT.0) CALL LMT6EVT6VD(NEVTOP,IR(LCIEVT),
     &        RX(LCEVTR),RX(LCEXDP),RX(LCSURF),IG(LCIBOU),GZ(LCHNEW),
     &        NCOL,NROW,NLAY,KKSTP,KKPER,GX(LCBUFF),IMT3D,INUHF,
     &        GX(LCBUFF),GX(LCBUFF))
            IF(IUNIT(39).GT.0) CALL LMT6ETS1VD(NETSOP,IR(LCIETS),
     &        RX(LCETSR),RX(LCETSX),RX(LCETSS),IG(LCIBOU),GZ(LCHNEW),
     &        NCOL,NROW,NLAY,KKSTP,KKPER,GX(LCBUFF),IMT3D,NETSEG,
     &        RX(LCPXDP),RX(LCPETM),NSEGAR,INUHF,GX(LCBUFF),GX(LCBUFF))
            IF(IUNIT(4).GT.0) CALL LMT6RIV6VD(NRIVER,MXRIVR,NRIVVL,
     &       RX(LCRIVR),IG(LCIBOU),GZ(LCHNEW),NCOL,NROW,NLAY,KKSTP,
     &       KKPER,IMT3D,MXSS,NSS,Y(LCSSM),NCOMP,Y(LCSSMC),INUHF,NTSS,
     &       GX(LCBUFF))
            IF(IUNIT(7).GT.0) CALL LMT6GHB6VD(NBOUND,MXBND,NGHBVL,
     &       RX(LCBNDS),GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,
     &       KKPER,IMT3D,MXSS,NSS,Y(LCSSM),NCOMP,Y(LCSSMC),INUHF,NTSS,
     &       GX(LCBUFF))
            IF(IUNIT(16).GT.0) CALL LMT6FHB1(IR(LCFLLC),RX(LCBDFV),NFLW,
     &       IG(LCIBOU),NCOL,NROW,NLAY,KKSTP,KKPER,IFHBD4,NFLWDIM,IMT3D,
     &       INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(50).GT.0) CALL LMT6MNW1(MNWSITE,NWELL2,MXWEL2,
     &       RZ(LCWEL2),IG(LCIBOU),NCOL,NROW,NLAY,NODES,KKSTP,KKPER,
     &       IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
            IF(IUNIT(40).GT.0) CALL LMT6DRT1VD(NDRTCL,MXDRT,RX(LCDRTF),
     &       GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,KKPER,
     &       IMT3D,NDRTVL,IDRTFL,NRFLOW,INUHF,MXSS,NTSS,NSS,Y(LCSSM),
     &       GX(LCBUFF))
        ELSE
C--SEAWAT: USE GWF SUBROUTINES IF IUNIT(57) EQUAL TO ZERO
        IF(IUNIT(1).GT.0) CALL LMT6BCF6(GZ(LCHNEW),IG(LCIBOU),GX(LCCR),
     &   GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),DELT,RX(LCSC1),
     &   RX(LCSC2),GX(LCHOLD),GX(LCBOTM),NBOTM,NCOL,NROW,NLAY,KKSTP,
     &   KKPER,GX(LCBUFF),IMT3D,INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(23).GT.0) CALL LMT6LPF1(GZ(LCHNEW),IG(LCIBOU),
     &   GX(LCCR),GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),DELT,
     &   X(LCSC1),X(LCSC2),GX(LCHOLD),GX(LCBOTM),NBOTM,NCOL,NROW,NLAY,
     &   KKSTP,KKPER,GX(LCBUFF),IMT3D,INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(37).GT.0) CALL LMT6HUF2(GZ(LCHNEW),IG(LCIBOU),
     &   GX(LCCR),GX(LCCC),GX(LCCV),ISS_MT3D,ISSFLG(KKPER),
     &   DELT,GX(LCHOLD),X(LCSC1),GX(LCBOTM),NBOTM,
     &   NCOL,NROW,NLAY,KKSTP,KKPER,X(LCHUFTHK),NHUF,IG(LCIZON),
     &   NZONAR,GX(LCRMLT),NMLTAR,GX(LCDELR),GX(LCDELC),
     &   GX(LCBUFF),IMT3D,iunit(47),x(LCVDHT),INUHF,
     &        GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),GX(LCBUFF),
     &        MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(2).GT.0) CALL LMT6WEL6(NWELLS,MXWELL,NWELVL,
     &   RX(LCWELL),IG(LCIBOU),NCOL,NROW,NLAY,KKSTP,KKPER,IMT3D,INUHF,
     &   MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(3).GT.0) CALL LMT6DRN6(NDRAIN,MXDRN,NDRNVL,
     &   RX(LCDRAI),GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,
     &   KKPER,IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(8).GT.0) CALL LMT6RCH6(NRCHOP,IR(LCIRCH),RX(LCRECH),
     &   IG(LCIBOU),NROW,NCOL,NLAY,KKSTP,KKPER,GX(LCBUFF),IMT3D,INUHF,
     &   GX(LCBUFF),GX(LCBUFF))
        IF(IUNIT(5).GT.0) CALL LMT6EVT6(NEVTOP,IR(LCIEVT),RX(LCEVTR),
     &   RX(LCEXDP),RX(LCSURF),IG(LCIBOU),GZ(LCHNEW),NCOL,NROW,NLAY,
     &   KKSTP,KKPER,GX(LCBUFF),IMT3D,INUHF,GX(LCBUFF),GX(LCBUFF))
        IF(IUNIT(39).GT.0) CALL LMT6ETS1(NETSOP,IR(LCIETS),RX(LCETSR),
     &   RX(LCETSX),RX(LCETSS),IG(LCIBOU),GZ(LCHNEW),NCOL,NROW,NLAY,
     &   KKSTP,KKPER,GX(LCBUFF),IMT3D,NETSEG,RX(LCPXDP),RX(LCPETM),
     &   NSEGAR,INUHF,GX(LCBUFF),GX(LCBUFF))
        IF(IUNIT(4).GT.0) CALL LMT6RIV6(NRIVER,MXRIVR,NRIVVL,
     &   RX(LCRIVR),IG(LCIBOU),GZ(LCHNEW),NCOL,NROW,NLAY,KKSTP,KKPER,
     &   IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(18).GT.0.AND.ILMTHEAD.EQ.0)
     &   CALL LMT6STR6(NSTREM,RX(LCSTRM_),IR(ICSTRM_),IG(LCIBOU),
     &   MXSTRM,NCOL,NROW,NLAY,KKSTP,KKPER,IMT3D,ILMTHEAD,INUHF,MXSS,
     &   NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(7).GT.0) CALL LMT6GHB6(NBOUND,MXBND,NGHBVL,
     &   RX(LCBNDS),GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,
     &   KKPER,IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(18).GT.0.AND.ILMTHEAD.EQ.1)
     &   CALL LMT6STR6(NSTREM,RX(LCSTRM_),IR(ICSTRM_),IG(LCIBOU),
     &   MXSTRM,NCOL,NROW,NLAY,KKSTP,KKPER,IMT3D,ILMTHEAD,INUHF)
        IF(IUNIT(17).GT.0) CALL LMT6RES1(IR(LCIRES),IR(LCIRSL),
     &   RX(LCBRES),RX(LCCRES),RX(LCBBRE),RX(LCHRES),IG(LCIBOU),
     &   GZ(LCHNEW),GX(LCBUFF),KKSTP,KKPER,NRES,NRESOP,
     &   NCOL,NROW,NLAY,IMT3D,INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(16).GT.0) CALL LMT6FHB1(IR(LCFLLC),RX(LCBDFV),NFLW,
     &   IG(LCIBOU),NCOL,NROW,NLAY,KKSTP,KKPER,IFHBD4,NFLWDIM,IMT3D,
     &   INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(50).GT.0) CALL LMT6MNW1(MNWSITE,NWELL2,MXWEL2,
     &   RZ(LCWEL2),IG(LCIBOU),NCOL,NROW,NLAY,NODES,KKSTP,KKPER,IMT3D,
     &   INUHF,MXSS,NTSS,NSS,Y(LCSSM),GX(LCBUFF))
        IF(IUNIT(40).GT.0) CALL LMT6DRT1(NDRTCL,MXDRT,RX(LCDRTF),
     &   GZ(LCHNEW),NCOL,NROW,NLAY,IG(LCIBOU),KKSTP,KKPER,
     &   IMT3D,NDRTVL,IDRTFL,NRFLOW,INUHF,MXSS,NTSS,NSS,Y(LCSSM),
     &   GX(LCBUFF))
C--SEAWAT: ENDIF FOR VDF OR GWF VERSION
        ENDIF
C
      ENDIF
C
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C END OF LMT6.INC
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C